/* 
** Copyright 1986, 1987, 1988, 1989, 1990, 1991 by the Condor Design Team
** 
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted,
** provided that the above copyright notice appear in all copies and that
** both that copyright notice and this permission notice appear in
** supporting documentation, and that the names of the University of
** Wisconsin and the Condor Design Team not be used in advertising or
** publicity pertaining to distribution of the software without specific,
** written prior permission.  The University of Wisconsin and the Condor
** Design Team make no representations about the suitability of this
** software for any purpose.  It is provided "as is" without express
** or implied warranty.
** 
** THE UNIVERSITY OF WISCONSIN AND THE CONDOR DESIGN TEAM DISCLAIM ALL
** WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE UNIVERSITY OF
** WISCONSIN OR THE CONDOR DESIGN TEAM BE LIABLE FOR ANY SPECIAL, INDIRECT
** OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
** OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
** OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
** OR PERFORMANCE OF THIS SOFTWARE.
** 
** Authors:  Allan Bricker and Michael J. Litzkow,
** 	         University of Wisconsin, Computer Sciences Dept.
** 
*/ 


#include <stdio.h>
#include <sys/types.h>

#include "trace.h"
#include "except.h"
#include "debug.h"
#include "condor_sys.h"

extern int	Syscalls;

static char *_FileName_ = __FILE__;		/* Used by EXCEPT (see except.h)     */

extern int CkptInProgress;
extern int SyscallInProgress;
extern int CkptWanted;

#if defined(ULTRIX) || defined(ULTRIX42) || defined(SUNOS40) || defined(SUNOS41) || defined(CMOS)
#define sighandler_t	void
#else
#define sighandler_t	int
#endif

sighandler_t
CKPT( sig, code, scp )
int					sig, code;
struct sigcontext	*scp;
{

	extern int CurrentSysCall;


	dprintf(D_CKPT,
		"CKPT: CkptWanted %d, CkptInProgress %d, SyscallInProgress %d\n",
			CkptWanted, CkptInProgress, SyscallInProgress);

	if( CkptInProgress || SyscallInProgress ) {
		if( SyscallInProgress ) {
			dprintf(D_ALWAYS, "CKPT: [%s] in progress, checkpoint wanted\n",
					CONDOR_SYSCALLNAME(CurrentSysCall));
		}
		CkptWanted = 1;
	} else {
		do_CKPT( 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
				 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
				 0, 0, 0, 0, 0, 0, 0, 0,
				 0, 0, 0, 0, 0, 0, 0, 0 );
	}
}
