/* 
** Copyright 1986, 1987, 1988, 1989, 1990, 1991 by the Condor Design Team
** 
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted,
** provided that the above copyright notice appear in all copies and that
** both that copyright notice and this permission notice appear in
** supporting documentation, and that the names of the University of
** Wisconsin and the Condor Design Team not be used in advertising or
** publicity pertaining to distribution of the software without specific,
** written prior permission.  The University of Wisconsin and the Condor
** Design Team make no representations about the suitability of this
** software for any purpose.  It is provided "as is" without express
** or implied warranty.
** 
** THE UNIVERSITY OF WISCONSIN AND THE CONDOR DESIGN TEAM DISCLAIM ALL
** WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE UNIVERSITY OF
** WISCONSIN OR THE CONDOR DESIGN TEAM BE LIABLE FOR ANY SPECIAL, INDIRECT
** OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
** OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
** OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
** OR PERFORMANCE OF THIS SOFTWARE.
** 
** Authors:  Allan Bricker and Michael J. Litzkow,
** 	         University of Wisconsin, Computer Sciences Dept.
** 
*/ 


#include "condor_sys.h"
#include <sys/types.h>
#include <sys/file.h>
#include <sys/param.h>
#include "ckpt_file.h"

#include <stdio.h>
#include "debug.h"

extern int	Syscalls;
extern RESTREC	RestartInfo;

#if defined(IRIX405)
off_t
_lseek( fd, offset, whence )
int fd;
off_t offset;
int whence;
{
	return (off_t)lseek( fd, offset, whence );
}
#endif

off_t
lseek( fd, offset, whence )
int fd;
off_t offset;
int whence;
{
	register FINFO *fi = &RestartInfo.rr_file[ fd ];
	off_t rval;
	int		orig;

	/*
	dprintf( D_ALWAYS, "Before lseek\n" );
	DumpOpenFds();
	*/

	orig = fd;
	fd = map_fd( fd );		/* Map user fd to physical fd */

	if( fd < 0 ) {		/* file wasn't open */
		return -1;
	}

	if( (Syscalls & SYS_LOCAL) || (fi->fi_flags & FI_NFS) ) {
		rval = (off_t) syscall( SYS_lseek, fd, offset, whence );
		SET_ERRNO;
	} else {
		rval = (off_t) REMOTE_syscall( CONDOR_lseek, fd, offset, whence );
	}

	/*
	dprintf( D_ALWAYS, "lseek(%d->%d) = %d\n", orig, fd, rval );
	dprintf( D_ALWAYS, "After lseek\n" );
	DumpOpenFds();
	*/
	return( rval );
}
